/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;

import Persistencia.RolFacadeLocal;
import Persistencia.UsuarioFacadeLocal;
import static Utils.Security.sha256;
import java.io.IOException;
import java.util.List;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.opencsv.CSVReader;
import java.io.StringReader;
import java.security.NoSuchAlgorithmException;
import java.util.Collections;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author aleja
 */
public class Admin extends HttpServlet {
    @EJB
    private RolFacadeLocal rolFacade;
    @EJB
    private UsuarioFacadeLocal usuarioFacade;


    /**
     * Maneja los CU relacionados con la administración de los usuarios
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que sea administrador
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() == 0){
            
            if(request.getParameter("add") != null){
                // CU dar de alta usuario en el sistema
                
                
                // Le pasa a la vista los Roles disponibles en el sistema                
                List<Dominio.Rol> rols = rolFacade.findAll();                
                request.setAttribute("rols", rols);
                
                RequestDispatcher rd = request.getRequestDispatcher("newuser.jsp");
                rd.forward(request, response);
                
            }else if(request.getParameter("addcsv") != null){
                // CU Añadir usuarios desde csv
                
                RequestDispatcher rd = request.getRequestDispatcher("newusers.jsp");
                rd.forward(request, response);
                
            }else{
                // Muestra el istado de los usuarios
                
                if(request.getParameter("remove") != null){
                    // CU Eliminar usuario
                    Dominio.Usuario usuario = usuarioFacade.find(request.getParameter("remove"));
                    usuario.setRol(rolFacade.find(99));
                    usuarioFacade.edit(usuario);
                }
                
                // Obtener lista de usuarios y ordenarla
                List<Dominio.Usuario> usuarios = usuarioFacade.findAll();
                Collections.sort(usuarios, (Dominio.Usuario u1, Dominio.Usuario u2) -> u1.getNombre().compareTo(u2.getNombre()));
                Collections.sort(usuarios, (Dominio.Usuario u1, Dominio.Usuario u2) -> u1.getApellidos().compareTo(u2.getApellidos()));
                Collections.sort(usuarios, (Dominio.Usuario u1, Dominio.Usuario u2) -> (u1.getRol().getId() - u2.getRol().getId()));

                request.setAttribute("usuarios", usuarios);

                RequestDispatcher rd = request.getRequestDispatcher("admin.jsp");
                rd.forward(request, response);
            }
        }else{
        
            // Si el usuario no tiene permiso, redirigir a página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    /**
     * Maneja los CU relacionados con la administración de los usuarios
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que sea administrador
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() == 0){
            
            if(request.getParameter("newuser") != null){
                // Añadir un usuario
                
                // Crea un nuevo objeto usuario
                Dominio.Usuario usuario = new Dominio.Usuario();
                
                // Y mete los datos dados por el usuario
                usuario.setLogin(request.getParameter("login"));
                usuario.setNombre(request.getParameter("nombre"));
                usuario.setApellidos(request.getParameter("apellidos"));
                usuario.setEmail(request.getParameter("email"));
                usuario.setRol(rolFacade.find(Integer.parseInt(request.getParameter("rol"))));
                
                // Intena poner la password (encriptada)
                String password = request.getParameter("password");
                try {
                    usuario.setPassword(sha256(password));
                } catch (NoSuchAlgorithmException ex) {
                    request.setAttribute("notsaved", true);
                    Logger.getLogger(Profile.class.getName()).log(Level.SEVERE, null, ex);
                }

                // Comprueba si existe y le guarda
                if(usuarioFacade.find(request.getParameter("login")) == null){
                    usuarioFacade.create(usuario);
                    request.setAttribute("saved", true);
                }else
                    request.setAttribute("notsaved", true);

                // Vuelve al listado de usuarios
                doGet(request, response);
                
            }if(request.getParameter("newcsv") != null){
                // Añadir usuarios de forma masiva
                
                // Leer el fichero CSV pasado
                CSVReader reader = new CSVReader(new StringReader(request.getParameter("csv")));
                Boolean error = false;
                String [] nextLine;
                
                // Comprobar que los campos son correctos (login, nombre, apellidos, email, password
                if((nextLine = reader.readNext()) != null &&
                        nextLine.length == 5 &&
                        nextLine[0].equals("login") &&
                        nextLine[1].equals("nombre") &&
                        nextLine[2].equals("apellidos") &&
                        nextLine[3].equals("email") &&
                        nextLine[4].equals("password")){
                    // Leer línea a línea los usuarios
                    while ((nextLine = reader.readNext()) != null) {
                        if(nextLine.length == 5){
                            Dominio.Usuario usuario = new Dominio.Usuario();
                            
                            usuario.setLogin(    nextLine[0]);
                            usuario.setNombre(   nextLine[1]);
                            usuario.setApellidos(nextLine[2]);
                            usuario.setEmail(    nextLine[3]);
                            usuario.setRol(      rolFacade.find(2)); // Alumno

                            String password =    nextLine[4];
                            try {
                                usuario.setPassword(sha256(password));
                            } catch (NoSuchAlgorithmException ex) {
                                error = true;
                                Logger.getLogger(Profile.class.getName()).log(Level.SEVERE, null, ex);
                            }
                            
                            // Si el usuario no existe se crea
                            if(usuarioFacade.find(nextLine[0]) == null){
                                try{
                                    usuarioFacade.create(usuario);
                                }catch(Exception e){
                                    error = true;
                                }
                            // Si existía, se modifica
                            }else{
                                try{
                                    usuarioFacade.edit(usuario);
                                }catch(Exception e){
                                    error = true;
                                }
                            }
                                
                        }
                    }
                }
                // Si se produjo un error, se indica al usuario
                if(error)
                    request.setAttribute("notsaved", true);
                else
                    request.setAttribute("saved", true);
                doGet(request, response);
            }
            
        }else{
        
            // Si el usuario no tiene permiso, redirigir a página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }

}
