/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;

import Persistencia.ApartadoFacadeLocal;
import Persistencia.CodigoFacadeLocal;
import Persistencia.CursoFacadeLocal;
import Persistencia.DiffFacadeLocal;
import Persistencia.EntregaFacadeLocal;
import Persistencia.TeoriaFacadeLocal;
import java.io.IOException;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author aleja
 */
public class Edit extends HttpServlet {
    @EJB
    private DiffFacadeLocal diffFacade;
    @EJB
    private EntregaFacadeLocal entregaFacade;
    @EJB
    private CodigoFacadeLocal codigoFacade;
    @EJB
    private TeoriaFacadeLocal teoriaFacade;
    @EJB
    private CursoFacadeLocal cursoFacade;
    @EJB
    private ApartadoFacadeLocal apartadoFacade;


    /**
     * Maneja los CU relacionados con la edición de tutoriales
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que no sea un alumno
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() <= 1){
            
            if(request.getParameter("aptdo") != null){
                // Editar un apartado
                
                // Se busca el apartado pedido por el usuario
                Dominio.Apartado apartado = apartadoFacade.find(Integer.parseInt(request.getParameter("aptdo")));

                // Se comprueba de qué tipo es el apartado
                if(apartado.getTeoria() != null){
                    // El apartado es de teoría
                    Dominio.Teoria teoria = apartado.getTeoria();

                    request.setAttribute("teoria", teoria);

                    // Se redirige al editor de texto html
                    RequestDispatcher rd = request.getRequestDispatcher("editorhtml.jsp");
                    rd.forward(request, response);

                }else if(apartado.getCodigo() != null){
                    // El apartado es de código
                    
                    request.setAttribute("aptdo", apartado.getId());
                    request.setAttribute("code",  apartado.getCodigo().getCodigo());

                    // Se redirige al editor de código
                    RequestDispatcher rd = request.getRequestDispatcher("editorwebgl.jsp");
                    rd.forward(request, response);
                }else if(apartado.getEntrega() != null){
                    // El apartado es de entrega
                    
                    request.setAttribute("aptdo", apartado.getId());
                    request.setAttribute("code",  apartado.getEntrega().getCodInicial());

                    // Se redirige al editor de código
                    RequestDispatcher rd = request.getRequestDispatcher("editorwebgl.jsp");
                    rd.forward(request, response);
                }else if(apartado.getDiff() != null){
                    // El apartado es de diff
                    
                    request.setAttribute("aptdo", apartado.getId());
                    request.setAttribute("code",  apartado.getDiff().getCodInicial());
                    request.setAttribute("code2", apartado.getDiff().getCodCorrecto());
                    request.setAttribute("diff" , "true");

                    // Se redirige al editor de código dual
                    RequestDispatcher rd = request.getRequestDispatcher("editorwebgl.jsp");
                    rd.forward(request, response);
                }else{
            
                    // Si no es de ningún tipo, se indica el error
                    RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                    rd.forward(request, response);
                }
                
               
            }else if (request.getParameter("curso") != null){
                // Editar la descripción del curso 
                
                // Se busca el curso solicitado
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("curso")));
                
                request.setAttribute("curso", curso);
                
                // Se redirige al editor de descripciones
                RequestDispatcher rd = request.getRequestDispatcher("editordescripcion.jsp");
                rd.forward(request, response);
            
              
            }else{
                // Nuevo tutorial  
                
                // Se redirige al editor de descripciones
                RequestDispatcher rd = request.getRequestDispatcher("editordescripcion.jsp");
                rd.forward(request, response);
            }
        }else{
            
            // Si el usuario no tiene permisos, redirigir a la página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    /**
     * Maneja los CU relacionados con la edición y creación de tutoriales
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que no sea un alumno
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() <= 1){
            
            if(request.getParameter("aptdo") != null){
                // Se va a editar un apartado
                
                // Obtener el apartado solicitado
                Dominio.Apartado apartado = apartadoFacade.find(Integer.parseInt(request.getParameter("aptdo")));

                // Comprobar de qué tipo es el apartado
                if(apartado.getTeoria() != null){
                    // El apartado es de teoría
                    
                    // Obtener el objeto teoría
                    Dominio.Teoria teoria = apartado.getTeoria();

                    // Obtener los cambios en el apartado
                    teoria.setTexto((String)request.getParameter("text"));

                    // Y se guardan los cambios
                    teoriaFacade.edit(teoria);
                    request.setAttribute("teoria", teoria);

                    // Se vuelve a redirigir al editor de texto
                    RequestDispatcher rd = request.getRequestDispatcher("editorhtml.jsp");
                    rd.forward(request, response);

                }else if(apartado.getCodigo() != null || apartado.getEntrega() != null || apartado.getDiff() != null){
                    // El apartado es de código, entrega o diff
                    
                    if(request.getParameter("edit") != null){
                        // Modo editar apartado
                        
                        if(apartado.getCodigo() != null){
                            //Modo editar codigo
                            
                            // Obtener el objeto codigo
                            Dominio.Codigo codigo = apartado.getCodigo();
                            
                            // Obtener los cambios en el apartado
                            codigo.setCodigo((String)request.getParameter("text"));

                            // Y se guardan
                            codigoFacade.edit(codigo);
                        }else if(apartado.getEntrega() != null){
                            //Modo editar entrega
                            
                            // Obtener el objeto entrega
                            Dominio.Entrega entrega = apartado.getEntrega();
                            
                            // Obtener los cambios en el apartado
                            entrega.setCodInicial((String)request.getParameter("text"));

                            // Y se guardan
                            entregaFacade.edit(entrega);
                        }else if(apartado.getDiff() != null){
                            //Modo editar diff
                            
                            // Obtener el objeto diff
                            Dominio.Diff diff = apartado.getDiff();
                            
                            // Obtener los cambios en el apartado de los dos cuadros de código
                            diff.setCodCorrecto((String)request.getParameter("text"));
                            diff.setCodInicial( (String)request.getParameter("text2"));
                            
                            // Y se guardan
                            diffFacade.edit(diff);
                            
                            request.setAttribute("diff", "true");
                            request.setAttribute("code2", (String)request.getParameter("text2"));
                        }else{
                            // Si no existe se indica el error
                            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                            rd.forward(request, response);
                        }
                            
                        
                        request.setAttribute("aptdo", apartado.getId());
                        request.setAttribute("code",  (String)request.getParameter("text"));
                        
                    } 
                    if(request.getParameter("execute") != null){
                        //Modo ejecutar codigo del apartado
                                                
                        
                        request.setAttribute("aptdo", apartado.getId());
                        
                        request.setAttribute("code", (String)request.getParameter("text"));
                        
                        // Si se está ejecutando el diff
                        if(request.getParameter("executediff")!=null)
                            request.setAttribute("scripts", (String)request.getParameter("text2"));
                        else
                            request.setAttribute("scripts", (String)request.getParameter("text"));
                        
                        // Si era un apartado de diff
                        if(request.getParameter("diff")!=null){
                            request.setAttribute("code2",(String)request.getParameter("text2"));
                            request.setAttribute("diff", "true");
                        }
                        
                        
                        // Para saltarse la protección de algunos navegadores de 
                        // enviar y recibir codigo javascript
                        response.setHeader("X-XSS-Protection", "0");
                    }
                    
                    // Y se vuelve a redirigir al editor de código
                    RequestDispatcher rd = request.getRequestDispatcher("editorwebgl.jsp");
                    rd.forward(request, response);
                }
                
            }else if(request.getParameter("curso") != null){
                // Se va a editar la descripción de un curso
                
                // Se obtiene el curso
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("curso")));
                
                if(curso == null){
                        // Si no existe se indica el error
                        RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                        rd.forward(request, response);
                }
                
                // Se obtienen los nuevos valores
                curso.setNombre(request.getParameter("nombre"));
                curso.setDescripcion(request.getParameter("descripcion"));
                curso.setMiniatura(request.getParameter("miniatura"));
                
                // Se guardan los cambios
                cursoFacade.edit(curso);
                
                // Se redirige a la página principal
                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }
        }else{
            
            // Si el usuario no tiene permisos, redirigir a la página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
       
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }

}
