/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;

import Persistencia.ApartadoFacadeLocal;
import Persistencia.CodigoFacadeLocal;
import Persistencia.CursoFacadeLocal;
import Persistencia.DiffFacadeLocal;
import Persistencia.EntregaFacadeLocal;
import Persistencia.TeoriaFacadeLocal;
import java.io.IOException;
import java.util.Collection;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author aleja
 */
public class NewTutorial extends HttpServlet {
    @EJB
    private DiffFacadeLocal diffFacade;
    @EJB
    private EntregaFacadeLocal entregaFacade;
    @EJB
    private CodigoFacadeLocal codigoFacade;
    @EJB
    private TeoriaFacadeLocal teoriaFacade;
    @EJB
    private ApartadoFacadeLocal apartadoFacade;
    @EJB
    private CursoFacadeLocal cursoFacade;
    
    /**
     * Maneja la creación de tutoriales y de nuevas páginas
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que no sea un alumno
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() <= 1){
            
            if(request.getParameter("id") != null){
                //AÑADIR NUEVA PAG A CURSO
                
                String tipo;
                if(request.getParameter("entrega") != null){
                    tipo = "entrega";
                }else if(request.getParameter("diff") != null){
                    tipo = "diff";
                }else{
                    tipo = "codigo";
                }
                
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));
                
                // Se crea el primer par de apartados
                curso = createApartados(curso, (curso.getApartadoCollection().size()/2) + 1, tipo);
                
                cursoFacade.edit(curso);
                
                
//                request.setAttribute("id", curso.getId());
////                request.setAttribute("page", (curso.getApartadoCollection().size()/2));
//                request.setAttribute("edit", "true");
                
                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
                
            }else{
                // NUEVO TUTORIAL
                Dominio.Curso curso = new Dominio.Curso();

                // Se fijan los nuevos valores
                curso.setNombre(request.getParameter("nombre"));
                curso.setDescripcion(request.getParameter("descripcion"));
                curso.setMiniatura(request.getParameter("miniatura"));

                // Se guardan los cambios en la BD
                curso = cursoFacade.createR(curso);

                // Se crea el primer par de apartados
                curso = createApartados(curso, 1, "codigo");
                
                cursoFacade.edit(curso);

                
//                request.setAttribute("id", curso.getId());
//                request.setAttribute("edit", true);
                
                RequestDispatcher rd = request.getRequestDispatcher("home");
                rd.forward(request, response);
            }
        }else{
            
            // Si el usuario no tiene  perimisos, redirigir a página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    
    /**
     * Crea un apartado de teoría y otro de código para el curso dado
     * con el orden dado por argumentos
     * 
     * @param curso
     * @param orden 
     */
    private Dominio.Curso createApartados(Dominio.Curso curso, int orden, String tipo){
        // Añadir apartado de teoria
        
        // Primero se crea el apartado
        Dominio.Apartado ap1 = new Dominio.Apartado();
        ap1.setIdCurso(curso);
        ap1.setOrden(orden);
        ap1 = apartadoFacade.createR(ap1);
        
        // Después se crea el objeto teoría
        Dominio.Teoria teoria = new Dominio.Teoria();
        teoria.setApartado(ap1);
        teoria.setIdAptdo(ap1.getId());
        teoria.setIdCurso(curso.getId());
        teoria.setTexto("<p> Texto de la teoría <p>");
        ap1.setTeoria(teoria);
        teoriaFacade.create(teoria);

        
        
        // Añadir apartado de código, entrega o comprobante
        
        // Primero se crea el apartado
        Dominio.Apartado ap2 = new Dominio.Apartado();
        ap2.setIdCurso(curso);
        ap2.setOrden(orden);
        ap2 = apartadoFacade.createR(ap2);
        
        // Después se crea el objeto entrega, codigo, o comprobante
        if(tipo.equals("entrega")){
            // Añadir apartado de entrega
            Dominio.Entrega entrega = new Dominio.Entrega();
            entrega.setApartado(ap2);
            entrega.setIdAptdo(ap2.getId());
            entrega.setCodInicial(" ");
            ap2.setEntrega(entrega);
            entregaFacade.create(entrega);
            
        }else if(tipo.equals("diff")){
            // Añadir apartado de diff
            Dominio.Diff diff = new Dominio.Diff();
            diff.setApartado(ap2);
            diff.setIdAptdo(ap2.getId());
            diff.setCodInicial(" ");
            diff.setCodCorrecto(" ");
            ap2.setDiff(diff);
            diffFacade.create(diff);
            
        }else{
            // Añadir apartado de codigo
            Dominio.Codigo codigo = new Dominio.Codigo();
            codigo.setApartado(ap2);
            codigo.setIdAptdo(ap2.getId());
            codigo.setIdCurso(curso.getId());
            codigo.setCodigo(" ");
            ap2.setCodigo(codigo);
            codigoFacade.create(codigo);
        }
        
        // Se añaden los apartados a la collection del curso para sobreescribir
        // el mecanismo de caché de JPA y que aparezcan en el sistema nada más 
        // crearse
        Collection<Dominio.Apartado> apartados = curso.getApartadoCollection();
        apartados.add(ap1);
        apartados.add(ap2);
        curso.setApartadoCollection(apartados);
        
        return curso;
    }
    
}
