/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;

import Persistencia.UsuarioFacadeLocal;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import static Utils.Security.sha256;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;

/**
 *
 * @author aleja
 */
public class Profile extends HttpServlet {
    @EJB
    private UsuarioFacadeLocal usuarioFacade;

    /**
     * Maneja el perfil de los usuarios y su modificación de contraseñas
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que el usuario exista
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() < 99){
        
            if(request.getParameter("edit") != null){
                // Ajustes de perfil

                // Si el administrador edita a un usuario
                if(user.getRol().getId() == 0 && request.getParameter("login") != null)
                    request.setAttribute("usuario", usuarioFacade.find(request.getParameter("login")));
                // Si es el propio usuario
                else
                    request.setAttribute("usuario", user);
                
                // Redirigir a la pagina de cambio de datos
                RequestDispatcher rd = request.getRequestDispatcher("editprofile.jsp");
                rd.forward(request, response);

            }else{
                // Ver perfil de usuario
                
                
                // Si el admin o un profesor queire ver el perfil de un alumno
                if(user.getRol().getId() <= 1 && request.getParameter("login") != null)
                    request.setAttribute("usuario", usuarioFacade.find(request.getParameter("login")));
                // Si es el propio usuario
                else
                    request.setAttribute("usuario", user);
                
                RequestDispatcher rd = request.getRequestDispatcher("profile.jsp");
                rd.forward(request, response);
            }
        }else{
            
            // Si el usuario no tiene permiso, mostrar la página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    /**
     * Maneja el perfil de los usuarios y su modificación de contraseñas
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        
        HttpSession session = request.getSession();
        
        // Comprobar por seguridad que el usuario este cambiando su password (o es admin)
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() == 0 || (user.getRol().getId() < 99 && user.getLogin().equals(request.getParameter("login")))){
            
            boolean error = false;
            
            // Obtiene el objeto usuario
            user = usuarioFacade.find(request.getParameter("login"));
            
            if(user==null){
                //ERROR
                RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                rd.forward(request, response);
            }
            
            // Cambio de datos personales
            if(request.getParameter("nombre") != null)
                user.setNombre(request.getParameter("nombre"));
            if(request.getParameter("apellidos") != null)
                user.setApellidos(request.getParameter("apellidos"));
            if(request.getParameter("email") != null)
                user.setEmail(request.getParameter("email"));
            
            
            // Cambio de contraseña
            if(request.getParameter("password") != null && !request.getParameter("password").equals("")){
                String newPassword = request.getParameter("password");
                try {
                    user.setPassword(sha256(newPassword));
                } catch (NoSuchAlgorithmException ex) {
                    request.setAttribute("notchanged", true);
                    Logger.getLogger(Profile.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            
            // Guardar los cambios
            try{
                usuarioFacade.edit(user);
            } catch (Exception e){
                error = true;
            }
            
            // Informa al usuario si se han modificado o no los datos
            request.setAttribute("usuario", user);
            if(error)
                request.setAttribute("notchanged", true);
            else
                request.setAttribute("changed", true);
            
            // Redirige otra vez a la edición del perfil
            RequestDispatcher rd = request.getRequestDispatcher("editprofile.jsp");
            rd.forward(request, response);
            
        }else{
            
            // Si el usuario no tiene permiso, mostrar la página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
        
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }

}
