/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Controlador;


import Persistencia.CursoFacadeLocal;
import Persistencia.EntregausuarioFacadeLocal;
import Persistencia.MatriculaFacadeLocal;
import Persistencia.UsuarioFacadeLocal;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author aleja
 */
public class Progress extends HttpServlet {
    @EJB
    private MatriculaFacadeLocal matriculaFacade;
    @EJB
    private EntregausuarioFacadeLocal entregausuarioFacade;
    @EJB
    private UsuarioFacadeLocal usuarioFacade;
    @EJB
    private CursoFacadeLocal cursoFacade;

    /**
     * Maneja el seguimiento de los usuarios y las calificaciones
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        
        
        // Comprobar por seguridad que sea profesor
        Dominio.Usuario user = (Dominio.Usuario)session.getAttribute("user");
        if(user.getRol().getId() == 1){
            
            if(request.getParameter("id") != null){
                // Seguimiento de un tutorial
                
                // Obtener el curso 
                Dominio.Curso curso = cursoFacade.find(Integer.parseInt(request.getParameter("id")));
                
                if(curso==null){
                    //ERROR
                    RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                    rd.forward(request, response);
                }
                
                request.setAttribute("curso", curso);
                
                
                // Obtener los Alumnos de ese curso
                List<Dominio.Usuario> usuarios = usuarioFacade.findAll();
                List<Dominio.Usuario> alumnos  = new ArrayList<>();
                for(Dominio.Usuario u : usuarios){
                    if(u.getRol().getId() == 2)
                        alumnos.add(u);
                }
                
                // Se ordenan alfabéticamente
                Collections.sort(alumnos, (Dominio.Usuario a1, Dominio.Usuario a2) -> a1.getNombre().compareTo(a2.getNombre()));
                Collections.sort(alumnos, (Dominio.Usuario a1, Dominio.Usuario a2) -> a1.getApellidos().compareTo(a2.getApellidos()));
                request.setAttribute("alumnos", alumnos);
                
                // Obtener los apartados de ese curso
                Collection<Dominio.Apartado> ap_coll = curso.getApartadoCollection();
                List<Dominio.Apartado> apartados = new ArrayList<>();
                for(Dominio.Apartado a : ap_coll){
                    if(a.getDiff()!=null || a.getEntrega()!=null)
                        apartados.add(a);
                }
                request.setAttribute("apartados", apartados);
                
                
                if(request.getParameter("score") != null){
                    // Fijar nota del alumno
                    
                    // Obtener la matrícula de ese alumno para ese curso
                    Dominio.MatriculaPK matriculapk = new Dominio.MatriculaPK(request.getParameter("login"), curso.getId());
                    Dominio.Matricula matricula = matriculaFacade.find(matriculapk);
                    
                    // Fijar la nota
                    if(matricula != null){
                        matricula.setNota(Integer.parseInt(request.getParameter("score")));
                    
                        matriculaFacade.edit(matricula);                    
                    }else{
                        //ERROR
                        RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
                        rd.forward(request, response);
                    }
                }
                
                // Redirigir al listado del tutorial
                RequestDispatcher rd = request.getRequestDispatcher("seguimientoalumno.jsp");
                rd.forward(request, response);
                
            }else if(request.getParameter("entrega") != null){
                // Mostrar entrega del usuario
                
                // Obtener de la BD la entrega del usuario
                Dominio.EntregausuarioPK entregausuariopk = new Dominio.EntregausuarioPK(request.getParameter("login"), Integer.parseInt(request.getParameter("entrega")));
                Dominio.Entregausuario entregausuario = entregausuarioFacade.find(entregausuariopk);
                
                request.setAttribute("entregausuario", entregausuario);
                request.setAttribute("code", entregausuario.getCodUsuario());
                request.setAttribute("scripts", entregausuario.getCodUsuario());
                request.setAttribute("aptdo", entregausuario.getEntrega().getApartado().getId());
                
                // Redirigir al editor de código con la entrega del usuario
                RequestDispatcher rd = request.getRequestDispatcher("editorwebgl.jsp");
                rd.forward(request, response);
                            
            }else if(request.getParameter("alumnos") != null){
                // Mostrar lista de alumnos
                
                // Obtener los Alumnos del sistema
                List<Dominio.Usuario> usuarios = usuarioFacade.findAll();
                List<Dominio.Usuario> alumnos  = new ArrayList<>();
                for(Dominio.Usuario u : usuarios){
                    if(u.getRol().getId() == 2)
                        alumnos.add(u);
                }
                
                // Se ordenan alfabéticamente
                Collections.sort(alumnos, (Dominio.Usuario a1, Dominio.Usuario a2) -> a1.getNombre().compareTo(a2.getNombre()));
                Collections.sort(alumnos, (Dominio.Usuario a1, Dominio.Usuario a2) -> a1.getApellidos().compareTo(a2.getApellidos()));
                request.setAttribute("alumnos", alumnos);
                
                // Redirige al listado de alumnos
                RequestDispatcher rd = request.getRequestDispatcher("listadoalumnos.jsp");
                rd.forward(request, response);
            }else{
                // Mostrar lista de cursos
                
                //  Obtiene la lista de tutoriales activos
                List<Dominio.Curso> cursos = cursoFacade.findAll();
                List<Dominio.Curso> cursos_activos = new ArrayList<>();
                for(Dominio.Curso c : cursos){
                    if(c.getActivo() == true)
                        cursos_activos.add(c);
                }
                
                // Ordenar el listado
                Collections.sort(cursos_activos, (Dominio.Curso c1, Dominio.Curso c2) -> (c1.getNumero() - c2.getNumero()));

                // Obtener los alumnos del sistema
                List<Dominio.Usuario> usuarios = usuarioFacade.findAll();
                int alumnos = 0;
                for(Dominio.Usuario u : usuarios){
                    if(u.getRol().getId() == 2)
                        alumnos ++;
                }
                request.setAttribute("cursos",  cursos_activos);
                request.setAttribute("alumnos", alumnos);
                
                // Mostar el listado de los tutoriales con datos de seguimiento
                RequestDispatcher rd = request.getRequestDispatcher("seguimientotutorial.jsp");
                rd.forward(request, response);
            }
        }else{
        
            //SI el usuario no tenia permiso, se redirige a la página de error
            RequestDispatcher rd = request.getRequestDispatcher("error.jsp");
            rd.forward(request, response);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
