<!--Header-->
<%@ include file="/includes/header.jsp" %>

<!--Barra de navegacin-->
<%@ include file="/includes/nav.jsp" %>


<% List<Usuario> usuarios = (List<Usuario>) request.getAttribute("usuarios");%>

<div class="container">
    <div class="row">
        
        <!--Avisos para el usuario-->
        <div class="col-md-12">
            <%if (request.getAttribute("saved") != null) { %>
                <div class="alert alert-success" role="alert">Se ha guardado correctamente el nuevo usuario</div>
            <%} else if (request.getAttribute("notsaved") != null) { %>
                <div class="alert alert-danger" role="alert">Se produjo un error y no se han podido guardar el nuevo usuario</div>
            <%}%>
        </div>
            
        <div class="col-md-12">
            <!-- Split button CREAR USUARIOS -->
            <div class="btn-group pull-right">
                <a href="admin?add" class="btn btn-primary"><span class="glyphicon glyphicon-user"></span>&nbspAadir nuevo usuario</a>
                <button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">
                    <span class="caret"></span>
                </button>
                <ul class="dropdown-menu">
                    <li><a href="admin?addcsv">Aadir usuarios desde CSV</a></li>
                </ul>
            </div>
        </div>

        <!--TABLA LISTADO DE USUARIOS-->
        <div class="col-md-12">
            <h4>Listado de usuarios</h4>
            <div class="table-responsive">
                <table id="mytable" class="table table-striped">
                    <!--Cabecera-->
                    <thead>
                        <th>Login</th>
                        <th>Nombre</th>
                        <th>Apellidos</th>
                        <th>Email</th>
                        <th>Rol</th>
                        <th>Perfil</th>
                        <th>Editar</th>
                        <th>Eliminar</th>
                    </thead>
                    <!--Cuerpo de la tabla-->
                    <tbody>
                        
                        <%for(int i = 0; i < usuarios.size(); i++){%>
                            <tr>
                                <td><%=usuarios.get(i).getLogin()%></td>
                                <td><%=usuarios.get(i).getNombre()%></td>
                                <td><%=usuarios.get(i).getApellidos()%></td>
                                <td><%=usuarios.get(i).getEmail()%></td>
                                <td><%if(usuarios.get(i).getRol().getId() <= 1){%>
                                        <span class="label label-success"><%=usuarios.get(i).getRol().getNombre()%></span>
                                    <%}else if(usuarios.get(i).getRol().getId() >= 99){%>
                                        <span class="label label-danger"><%=usuarios.get(i).getRol().getNombre()%></span>
                                    <%}else{%>
                                        <span class="label label-default"><%=usuarios.get(i).getRol().getNombre()%></span>                   
                                    <%}%>
                                </td>
                                <td><p data-placement="top"><a href="profile?login=<%=usuarios.get(i).getLogin()%>" class="btn btn-primary btn-xs"><span class="glyphicon glyphicon-user" data-toggle="tooltip" title="Ver perfil del usuario"></span></a></p></td>
                                <td><p data-placement="top"><a href="profile?login=<%=usuarios.get(i).getLogin()%>&edit" class="btn btn-primary btn-xs" data-toggle="tooltip" title="Editar usuario"><span class="glyphicon glyphicon-pencil"></span></a></p></td>
                                <td><p data-placement="top"><a href="admin?remove=<%=usuarios.get(i).getLogin()%>" data-toggle="tooltip" title="Eliminar usuario" onclick="return confirm('Ests seguro que quieres eliminar a <%=usuarios.get(i).getNombre()%> <%=usuarios.get(i).getApellidos()%>?')" class="btn btn-danger btn-xs"><span class="glyphicon glyphicon-trash"></span></a></p></td>
                            </tr>
                        <%}%>
                        
                    </tbody>
                </table>

            </div>

        </div>
    </div>
</div>


<script>
    $(document).ready(function(){
        $('[data-toggle="tooltip"]').tooltip();   
    });
</script>    

<!--Footer-->
<%@ include file="/includes/footer.jsp" %>