
<!--Header-->
<%@ include file="/includes/header.jsp" %>

<!--Barra de navegacin-->
<%@ include file="/includes/nav.jsp" %>


<%@ page import="java.text.DecimalFormat"%>
<%@ page import="Dominio.Matricula" %>
<%  boolean admin = (user.getRol().getId() == 0);
    Usuario usuario = (Usuario) request.getAttribute("usuario");%>

<div class="container">
    <div class="col-md-8 col-md-offset-2">
        <div class="panel panel-primary">
            <!--PERFIL DEL USUARIO-->
            <div class="panel-heading">
                <h3 class="panel-title">Perfil de usuario <%if (admin || usuario.getLogin().equals(user.getLogin())) {%><a href="profile?login=<%=usuario.getLogin()%>&edit" class="btn btn-xs pull-right" data-toggle="tooltip" title="Editar perfil"><span class="glyphicon glyphicon-pencil"></span></a><%}%></h3>
            </div>
            
            <!--CUADRO DE DATOS-->
            <div class="panel-body">
                <div class="col-md-4">
                    Nombre: <br>
                    Correo electrnico: <br>
                    Rol:
                </div>
                <div class="col-md-8">
                    <%=usuario.getNombre()%> <%=usuario.getApellidos()%> <br>
                    <%=usuario.getEmail()%> <br>
                    <%=usuario.getRol().getNombre()%>
                </div>

                <div class="col-md-12">
                    <hr>
                </div>

                <% //  Clculo de nota media
                    int comenzados = 0, completados = 0, nota = 0, n = 0;
                    Collection<Matricula> matriculas = usuario.getMatriculaCollection();
                    for (Matricula m : matriculas) {
                        if (m.getCompletado() == true) {
                            completados++;
                        }

                        comenzados++;

                        if (m.getNota() != null) {
                            nota += m.getNota();
                            n++;
                        }
                    }
                %>

                <div class="col-md-4">
                    Tutoriales comenzados: <br>
                    Tutoriales completados: <br>
                    <br>
                    Nota media: 
                </div>
                <div class="col-md-8">
                    <%=comenzados%> <br>
                    <%=completados%> <br>
                    <br>
                    <!--CALIFICACIN MEDIA-->
                    <% if (n == 0) {%>
                    <span class="label label-default" style="font-size:8pt; vertical-align: middle;">No disponible</span>
                    <%} else {
                        float score = (float) nota / n;
                        if (score >= 0 && score < 5) {%>
                            <span class="label label-danger" style="font-size:8pt; vertical-align: middle;">Suspenso - <%=new DecimalFormat("#.##").format(score)%></span>
                        <%} else if (score >= 5 && score < 6) {%>
                            <span class="label label-warning" style="font-size:8pt; vertical-align: middle;">Aprobado - <%=new DecimalFormat("#.##").format(score)%></span>
                        <%} else if (score >= 6 && score < 7) {%>
                            <span class="label label-info" style="font-size:8pt; vertical-align: middle;">Bien - <%=new DecimalFormat("#.##").format(score)%></span>
                        <%} else if (score >= 7 && score < 9) {%>
                            <span class="label label-primary" style="font-size:8pt; vertical-align: middle;">Notable - <%=new DecimalFormat("#.##").format(score)%></span>
                        <%} else if (score >= 9) {%>
                            <span class="label label-success" style="font-size:8pt; vertical-align: middle;">Sobresaliente - <%=new DecimalFormat("#.##").format(score)%></span>
                        <%}
                    }%>
                </div>

            </div>
        </div>
    </div>
</div>

<!--LISTADO DE TUTORIALES REALIZADOS-->
<div class="container">
    <div class="col-md-8 col-md-offset-2">
        <div class="table-responsive">

            <table id="mytable" class="table table-striped">
                <!--Cabecera de la tabla-->
                <thead>
                        <th>Tutorial</th>
                        <th>Estado</th>
                        <th>Nota</th>
                </thead>
                
                <!--Cuerpo de la tabla-->
                <tbody>
                    <%for(Matricula m : matriculas){%>
                        <tr>
                            <td>Tutorial n<%=m.getCurso().getNumero()%> : <%=m.getCurso().getNombre()%></td>

                            <%if(m.getCompletado()){%>
                                <!--FINALIZADO-->
                                <td><a href="tutorial?id=<%=m.getCurso().getId()%>" class="label label-success" data-toggle="tooltip" title="El alumno ha completado el tutorial">Completado</a></td>
                            <%}else{%>
                                <!--NO FINALIZADO-->
                                <td><a href="tutorial?id=<%=m.getCurso().getId()%>" class="label label-warning" data-toggle="tooltip" title="El alumno ha empezado el tutorial pero no le ha finalizado">No completado</a></td>
                            <%}%>
                            
                            <td>
                                <!--CALIFICACIN-->
                                <%boolean prf = (user.getRol().getId()==1);
                                if(m.getNota() != null){
                                    int score = m.getNota();
                                    
                                    if (score >= 0 && score < 5) {%>
                                        <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-danger" style="font-size:8pt; vertical-align: middle;">Suspenso - <%=score%></a>
                                    <%} else if (score >= 5 && score < 6) {%>
                                        <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-warning" style="font-size:8pt; vertical-align: middle;">Aprobado - <%=score%></a>
                                    <%} else if (score >= 6 && score < 7) {%>
                                        <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-info" style="font-size:8pt; vertical-align: middle;">Bien - <%=score%></a>
                                    <%} else if (score >= 7 && score < 9) {%>
                                        <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-primary" style="font-size:8pt; vertical-align: middle;">Notable - <%=score%></a>
                                    <%} else if (score >= 9) {%>
                                        <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-success" style="font-size:8pt; vertical-align: middle;">Sobresaliente - <%=score%></a>
                                    <%}
                                }else{%>
                                    <a href="<%if(prf){%>progress<%}else{%>tutorial<%}%>?id=<%=m.getCurso().getId()%>" class="label label-default" style="font-size:8pt; vertical-align: middle;">No disponible</a>
                                <%}%>
                            </td>
                        </tr>
                    <%}%>
                </tbody>
                
            </table>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $('[data-toggle="tooltip"]').tooltip();
    });
</script>  

<!--Footer-->
<%@ include file="/includes/footer.jsp" %>